(*  GREATIS IMAGE EDITOR                                 *)
(*  Copyright (C) 2005-2014 Greatis Software             *)
(*                                                       *)
(*  http://www.greatis.com/delphicb/imgedit/             *)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgEdt, StdDraw, StdColors, StdCtrls, ImgAdj, StdAlgs, Menus, ComCtrls,
  ToolWin, ExtDlgs, ExtCtrls, ImgSize, PlugDraw, ImgList;

type
  TfrmMain = class(TForm)
    cmpStandardDrawer: TStandardDrawer;
    pnlImageEditor: TPanel;
    cntImageEditor: TImageEditor;
    stbMain: TStatusBar;
    imlToolbars: TImageList;
    tbrMail: TToolBar;
    mmnMain: TMainMenu;
    mniFile: TMenuItem;
    mniFileNew: TMenuItem;
    mniFileOpen: TMenuItem;
    mniFileSave: TMenuItem;
    mniFileSaveAs: TMenuItem;
    mniFileSep: TMenuItem;
    mniFileExit: TMenuItem;
    mniEdit: TMenuItem;
    mniEditCut: TMenuItem;
    mniEditCopy: TMenuItem;
    mniEditPaste: TMenuItem;
    mniEditCrop: TMenuItem;
    mniHelp: TMenuItem;
    mniHelpAbout: TMenuItem;
    pnlToolbars: TPanel;
    tbrTools: TToolBar;
    tbtZoom: TToolButton;
    tbtSelection: TToolButton;
    tbtDropper: TToolButton;
    tbtEraser: TToolButton;
    tbtPencil: TToolButton;
    tbtLine: TToolButton;
    tbtBrush: TToolButton;
    tbtSpray: TToolButton;
    tbtFill: TToolButton;
    tbtRectangle: TToolButton;
    tbtRoundedRectangle: TToolButton;
    tbtEllipse: TToolButton;
    tbtText: TToolButton;
    tbrZoom: TToolBar;
    tbtZoomIn: TToolButton;
    tbtActualSize: TToolButton;
    tbtZoomOut: TToolButton;
    tbtFitToClient: TToolButton;
    tbrSelection: TToolBar;
    tbtDelete: TToolButton;
    tbtCut: TToolButton;
    tbtCopy: TToolButton;
    tbtPaste: TToolButton;
    tbtPasteFromFile: TToolButton;
    tbtCrop: TToolButton;
    tbrEraser: TToolBar;
    tbtEraserSquare: TToolButton;
    tbtEraserCircle: TToolButton;
    tbtEraserSep: TToolButton;
    tbtEraser12: TToolButton;
    tbtEraser8: TToolButton;
    tbtEraser4: TToolButton;
    tbrPencil: TToolBar;
    tbtPencil9: TToolButton;
    tbtPencil7: TToolButton;
    tbtPencil5: TToolButton;
    tbtPencil3: TToolButton;
    tbtPencil1: TToolButton;
    tbrLine: TToolBar;
    tbtLine9: TToolButton;
    tbtLine7: TToolButton;
    tbtLine5: TToolButton;
    tbtLine3: TToolButton;
    tbtLine1: TToolButton;
    tbrBrush: TToolBar;
    tbtBrushSquare: TToolButton;
    tbtBrushCircle: TToolButton;
    tbtBrushSeparator: TToolButton;
    tbtBrush12: TToolButton;
    tbtBrush8: TToolButton;
    tbtBrush4: TToolButton;
    tbtBrushNS: TToolButton;
    tbtBrushNWSE: TToolButton;
    tbtBrushWE: TToolButton;
    tbtBrushNESW: TToolButton;
    tbrSpray: TToolBar;
    tbtSpray1: TToolButton;
    tbtSpray2: TToolButton;
    tbtSpray3: TToolButton;
    tbtSpray4: TToolButton;
    tbtSpray5: TToolButton;
    tbtSpray6: TToolButton;
    tbtSpray7: TToolButton;
    tbtSpray8: TToolButton;
    tbtSpray9: TToolButton;
    tbrFill: TToolBar;
    tbtBrushSolid: TToolButton;
    tbtBrushBDiag: TToolButton;
    tbtBrushFDiag: TToolButton;
    tbtBrushCross: TToolButton;
    tbtBrushDiagCross: TToolButton;
    tbtBrushHor: TToolButton;
    tbtBrushVer: TToolButton;
    tbrShapes: TToolBar;
    tbtShapeEmpty: TToolButton;
    tbtShapeSolid: TToolButton;
    tbtShapeBDiagonal: TToolButton;
    tbtShapeFDiagonal: TToolButton;
    tbtShapeCross: TToolButton;
    tbtShapeDiagCross: TToolButton;
    tbtShapeHor: TToolButton;
    tbtShapeVer: TToolButton;
    tbtShapeLine9: TToolButton;
    tbtShapeLine7: TToolButton;
    tbtShapeLine3: TToolButton;
    tbtShapeLine1: TToolButton;
    tbtShapeLine5: TToolButton;
    tbtShapeSep: TToolButton;
    tbrText: TToolBar;
    tbtTextLeft: TToolButton;
    tbtTextCenter: TToolButton;
    tbtTextRight: TToolButton;
    tbtTextAlignSep: TToolButton;
    tbtTextTop: TToolButton;
    tbtTextMiddle: TToolButton;
    tbtTextBottom: TToolButton;
    tbtTextFontSep: TToolButton;
    tbtTextFont: TToolButton;
    fndText: TFontDialog;
    mniImage: TMenuItem;
    mniImageResize: TMenuItem;
    mniImageResample: TMenuItem;
    opdImage: TOpenPictureDialog;
    mniEditDelete: TMenuItem;
    mniEditSep: TMenuItem;
    mniEditUndo: TMenuItem;
    mniEditRedo: TMenuItem;
    tbtLineSep: TToolButton;
    tbtLineClose: TToolButton;
    mniImageAdjust: TMenuItem;
    spdImage: TSavePictureDialog;
    mniPasteFromFile: TMenuItem;
    imlMain: TImageList;
    tbtFileNew: TToolButton;
    tbtFileOpen: TToolButton;
    tbtFileSave: TToolButton;
    tbtFileSep: TToolButton;
    tbtImageAdjust: TToolButton;
    tbtImageResize: TToolButton;
    tbtImageResample: TToolButton;
    tbtImageSep: TToolButton;
    tbtHelpAbout: TToolButton;
    tbtEditUndo: TToolButton;
    tbtEditRedo: TToolButton;
    tbtEditSep: TToolButton;
    pnlColor: TPanel;
    cntColors: TColorToolbar;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure tbtToolsClick(Sender: TObject);
    procedure tbtZoomInClick(Sender: TObject);
    procedure tbtActualSizeClick(Sender: TObject);
    procedure tbtZoomOutClick(Sender: TObject);
    procedure tbtFitToClientClick(Sender: TObject);
    procedure eveDeleteClick(Sender: TObject);
    procedure eveCutClick(Sender: TObject);
    procedure eveCopyClick(Sender: TObject);
    procedure evePasteClick(Sender: TObject);
    procedure evePasteFromFileClick(Sender: TObject);
    procedure tbtModeClick(Sender: TObject);
    procedure tbtLineCloseClick(Sender: TObject);
    procedure cntImageEditorColorsChange(Sender: TObject);
    procedure tbtValueClick(Sender: TObject);
    procedure tbtTextHorClick(Sender: TObject);
    procedure tbtTextVerClick(Sender: TObject);
    procedure cntImageEditorToolChange(Sender: TObject);
    procedure tbtTextFontClick(Sender: TObject);
    procedure eveFileOpenClick(Sender: TObject);
    procedure eveFileNewClick(Sender: TObject);
    procedure eveImageResampleClick(Sender: TObject);
    procedure eveImageResizeClick(Sender: TObject);
    procedure eveEditUndoClick(Sender: TObject);
    procedure eveEditRedoClick(Sender: TObject);
    procedure eveImageAdjustClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cntImageEditorUndoChange(Sender: TObject);
    procedure eveFileSaveClick(Sender: TObject);
    procedure mniFileSaveAsClick(Sender: TObject);
    procedure eveHelpAboutClick(Sender: TObject);
    procedure eveCropClick(Sender: TObject);
    procedure cmpStandardDrawerMove(Sender: TObject;
      Editor: TCustomImageEditor; var Processed: Boolean);
    procedure cmpStandardDrawerMouseLeave(Sender: TObject;
      Editor: TCustomImageEditor; var Processed: Boolean);
  private
    { Private declarations }
    FFileName: string;
    function CheckSave: TModalResult;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses About;

{$R *.DFM}

const
  JpegQuality = 50;

function TfrmMain.CheckSave: TModalResult;
begin
  with cntImageEditor do
    if Modified then
    begin
      Result:=MessageDlg('Image was modified. Save it?',mtInformation,mbYesNoCancel,0);
      if Result=mrYes then
        with spdImage do
        begin
          FileName:=FFileName;
          if Execute then
            if FilterIndex=1 then SaveImageToFile(FileName)
            else SaveImageToJpeg(FileName,JpegQuality);
        end;
    end
    else Result:=mrYes;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  if Height<450 then Height:=450;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  pnlToolbars.Width:=2*tbrTools.Width;
  cntColors.AddDefaultColors([dcGrayScaleLarge,dcVGAColors,dcAdvanced],True);
  cntImageEditor.CreateImage(640,480);
end;

procedure TfrmMain.tbtToolsClick(Sender: TObject);
var
  i,T: Integer;
begin
  with Sender as TToolButton do
    case Tag of
      toolRectangle,toolRoundRectangle,toolEllipse: T:=toolRectangle
    else T:=Tag;
    end;
  for i:=0 to Pred(ComponentCount) do
    if (Components[i] is TToolbar) and (Components[i].Tag<>-1) then
      with TToolbar(Components[i]) do
        Visible:=Tag=T;
  cntImageEditor.Tool:=(Sender as TToolButton).Tag;
end;

procedure TfrmMain.tbtZoomInClick(Sender: TObject);
begin
  cntImageEditor.ZoomIn;
end;

procedure TfrmMain.tbtActualSizeClick(Sender: TObject);
begin
  cntImageEditor.Scale:=100;
end;

procedure TfrmMain.tbtZoomOutClick(Sender: TObject);
begin
  cntImageEditor.ZoomOut;
end;

procedure TfrmMain.tbtFitToClientClick(Sender: TObject);
begin
  cntImageEditor.FitToClient;
end;

procedure TfrmMain.eveDeleteClick(Sender: TObject);
begin
  cntImageEditor.DeleteClip;
end;

procedure TfrmMain.eveCutClick(Sender: TObject);
begin
  cntImageEditor.CutClipToClipboard;
end;

procedure TfrmMain.eveCopyClick(Sender: TObject);
begin
  cntImageEditor.CopyClipToClipboard;
end;

procedure TfrmMain.evePasteClick(Sender: TObject);
begin
  cntImageEditor.PasteClipFromClipboard;
end;

procedure TfrmMain.evePasteFromFileClick(Sender: TObject);
begin
  with opdImage do
  begin
    FileName:='';
    if Execute then
      cntImageEditor.LoadClipFromFile(FileName);
  end;
end;

procedure TfrmMain.eveCropClick(Sender: TObject);
begin
  cntImageEditor.CropBySelection;
end;

procedure TfrmMain.tbtModeClick(Sender: TObject);
begin
  cntImageEditor.Mode:=(Sender as TToolButton).Tag;
end;

procedure TfrmMain.tbtLineCloseClick(Sender: TObject);
begin
  cntImageEditor.Mode:=Integer((Sender as TToolButton).Down);
end;

procedure TfrmMain.cntImageEditorColorsChange(Sender: TObject);
begin
  cntColors.UpdateColors;
end;

procedure TfrmMain.tbtValueClick(Sender: TObject);
begin
  cntImageEditor.Value:=(Sender as TToolButton).Tag;
end;

procedure TfrmMain.tbtTextHorClick(Sender: TObject);
begin
  with cntImageEditor do
    Mode:=Mode and not 3 or (Sender as TToolButton).Tag;
end;

procedure TfrmMain.tbtTextVerClick(Sender: TObject);
begin
  with cntImageEditor do
    Mode:=Mode and 3 or (Sender as TToolButton).Tag;
end;

procedure TfrmMain.cntImageEditorToolChange(Sender: TObject);

var
  i,Bar,Btn: Integer;

  function CompareTools(ToolbarTool,EditorTool: Integer): Boolean;
  begin
    case EditorTool of
      toolRectangle,toolRoundRectangle,toolEllipse: Result:=ToolbarTool=toolRectangle
    else Result:=EditorTool=ToolbarTool;
    end;
  end;

begin
  with tbrTools do
    for Btn:=0 to Pred(ButtonCount) do
      with Buttons[Btn] do
      begin
        Down:=Tag=cntImageEditor.Tool;
        if Down and Assigned(OnClick) then OnClick(Buttons[Btn]);
      end;
  for Bar:=0 to Pred(ComponentCount) do
    if (Components[Bar] is TToolbar) and
      CompareTools(TToolbar(Components[Bar]).Tag,cntImageEditor.Tool) then
      with TToolbar(Components[Bar]) do
        for Btn:=0 to Pred(ButtonCount) do
          with Buttons[Btn] do
            if Down and Assigned(OnClick) then
              OnClick(Buttons[Btn]);
  with mniEdit do
    for i:=0 to Pred(Count) do
      with Items[i] do
        if Tag=1 then Enabled:=cntImageEditor.Tool=toolSelection;
end;

procedure TfrmMain.tbtTextFontClick(Sender: TObject);
begin
  with fndText do
  begin
    Font:=cntImageEditor.Font;
    if Execute then cntImageEditor.Font:=Font;
  end;
end;

procedure TfrmMain.eveFileOpenClick(Sender: TObject);
begin
  if CheckSave<>mrCancel then
    with opdImage do
    begin
      FileName:='';
      if Execute then
      begin
        FFileName:=FileName;
        cntImageEditor.LoadImageFromFile(FFileName);
      end;
    end;
end;

procedure TfrmMain.eveFileNewClick(Sender: TObject);
var
  W,H: Integer;
  HA: THorAlign;
  VA: TVerAlign;
  S: Boolean;
begin
  if CheckSave<>mrCancel then
  begin
    with Screen do
    begin
      W:=Width div 2;
      H:=Height div 2;
    end;
   if ImageSize(W,H,HA,VA,S,[]) then cntImageEditor.CreateImage(W,H);
  end;
end;

procedure TfrmMain.eveImageResampleClick(Sender: TObject);
begin
  cntImageEditor.ResampleDialog;
end;

procedure TfrmMain.eveImageResizeClick(Sender: TObject);
begin
  cntImageEditor.ResizeDialog;
end;

procedure TfrmMain.eveEditUndoClick(Sender: TObject);
begin
  cntImageEditor.Undo;
end;

procedure TfrmMain.eveEditRedoClick(Sender: TObject);
begin
  cntImageEditor.Redo;
end;

procedure TfrmMain.eveImageAdjustClick(Sender: TObject);
begin
  AdjustImage(cntImageEditor);
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=CheckSave<>mrCancel;
end;

procedure TfrmMain.cntImageEditorUndoChange(Sender: TObject);
begin
  with Sender as TCustomImageEditor do
  begin
    with mniEditUndo do
    begin
      Enabled:=CanUndo;
      if Enabled then Caption:='Undo '+UndoName[UndoPosition]
      else Caption:='Undo';
      tbtEditUndo.Enabled:=Enabled;
    end;
    with mniEditRedo do
    begin
      Enabled:=CanRedo;
      if Enabled then Caption:='Redo '+UndoName[Succ(UndoPosition)]
      else Caption:='Redo';
      tbtEditRedo.Enabled:=Enabled;
    end;
  end;
end;

procedure TfrmMain.eveFileSaveClick(Sender: TObject);
begin
  with cntImageEditor do
    if Modified then
      if FFileName<>'' then
        if AnsiUpperCase(ExtractFileExt(FFileName))='.BMP' then SaveImageToFile(FFileName)
       else SaveImageToJpeg(FFileName,JpegQuality)
      else mniFileSaveAs.OnClick(mniFileSaveAs);
end;

procedure TfrmMain.mniFileSaveAsClick(Sender: TObject);
begin
  with spdImage do
  begin
    FileName:=FFileName;
    if Execute then
    begin
      FFileName:=FileName;
      with cntImageEditor do
        if FilterIndex=1 then SaveImageToFile(FileName)
        else SaveImageToJpeg(FileName,JpegQuality);
    end;
  end;
end;

procedure TfrmMain.eveHelpAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMain.cmpStandardDrawerMove(Sender: TObject;
  Editor: TCustomImageEditor; var Processed: Boolean);
var
  RGB: TRGBQuad;
begin
  with Editor,Canvas,NewMove,stbMain do
  begin
    if (X>=0) and (X<ImageWidth) and (Y>=0) and (Y<ImageHeight) then
    begin
      RGB:=TRGBQuad(ColorToRGB(Pixels[X,Y]));
      with RGB do
        SimpleText:=Format('X: %d  Y: %d    R: %d  G: %d  B: %d',[X,Y,rgbRed,rgbGreen,rgbBlue]);
    end
    else SimpleText:='';
  end;
end;

procedure TfrmMain.cmpStandardDrawerMouseLeave(Sender: TObject;
  Editor: TCustomImageEditor; var Processed: Boolean);
begin
  stbMain.SimpleText:='';
end;

end.
